
#include "stdafx.h"
#include "resource.h"
#include "chatwindow.h"
#include "mTabChat.h"
#include "options.h"


HANDLE chat_hook;
DWORD defStyle;		// defaultowe style okna
HWND defParent;		// defaultowy rodzic okna czata
RECT defRect;		// polozenie okien standardowe;


// przywraca domyslne opcje i style dla otwartych okien
void DefaultWindows() {
	int nWidth = defRect.right - defRect.left;
	int nHeight = defRect.bottom - defRect.top;
	int j = tab.size();
	for (int n=0; n<j; n++) {
		ShowWindow(tab[n].Handle, SW_HIDE);
		SetParent(tab[n].Handle, defParent);
		SetWindowLong(tab[n].Handle,GWL_STYLE, defStyle);
		MoveWindow(tab[n].Handle, (GetSystemMetrics(SM_CXSCREEN) - nWidth)/2,
					(GetSystemMetrics(SM_CYSCREEN) - nHeight)/2, nWidth, nHeight, TRUE);
		ShowWindow(tab[n].Handle, SW_SHOW);
	}
}


BOOL CALLBACK EnumChildProc(HWND hWnd, LPARAM lParam) {
	tab_info_t* ti = (tab_info_t*) lParam;
	char buf[10]={0};
	GetClassName(hWnd, buf, sizeof(buf));
	if (strcmp(buf, "TMemo") == 0) {
		ti->hMemo = hWnd;
		return false;
	}
	return true;
}

// timer // hack do zmiany polozenia chatwindow
static int TimerCallback(WPARAM wParam, LPARAM lParam) {
	TimerDef *timer = (TimerDef *) lParam;
	if (wParam == TLEN_TIMER_EVENT_FIRED)
		SetTabTitle();
	return 0;
}


// obsluga hooka na chatwindow
int ChatWindowEvent(WPARAM wParam, LPARAM lParam) {
	TlenChatWindowEventDef* ev = (TlenChatWindowEventDef*) wParam;

	// jesli to nie czat/konferencja, to zakoncz
	if (!(ev->WindowInfo->Flags & CHATWINDOW_SHOWFLAG_CONFERENCE)) return 0;

	switch (ev->EventID) {

		case TLEN_CHATWINDOW_EVENT_AFTEROPENED: {
			// jesli nie ma okna naszego to stworz
			if (hOkno == NULL) {
				// pobierz styl okna czata / rodzica / polozenie
				defStyle = GetWindowLong(ev->WindowInfo->Handle, GWL_STYLE);
				defParent = GetParent(ev->WindowInfo->Handle);
				GetWindowRect(ev->WindowInfo->Handle, &defRect);
				// tworzenie okna pluginu
				hOkno = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DIALOG), NULL, (DLGPROC) DialogProc);
				MoveWindow(hOkno, (GetSystemMetrics(SM_CXSCREEN) - config.width)/2, (GetSystemMetrics(SM_CYSCREEN) - config.height)/2, config.width, config.height, TRUE);
			}

			tab_info_t ti;
			InitializeStruct(ti);
				ti.Handle = ev->WindowInfo->Handle;
				if (ev->WindowInfo->Contact.ContactID)	// przy konferencji / wywali av / bo jet NULL
					ti.RoomID = ev->WindowInfo->Contact.ContactID;
				ti.Name = "Chat";
			tab.push_back(ti);

			int idx = tab.size()-1;			// index wstawianej zakaldki;

			EnumChildWindows(ev->WindowInfo->Handle, EnumChildProc, (LPARAM) &tab[idx]);
	
			SetWindowLong(ev->WindowInfo->Handle, GWL_STYLE, WS_CHILD);	// ustawienie stylu okna
			SetParent(ev->WindowInfo->Handle, hOkno);					// zmiana rodzica okna ;)

			// dodanie zakladki
			TCITEM item;
				item.mask = TCIF_TEXT;
				item.pszText = (char*)tab[idx].Name.c_str();
			TabCtrl_InsertItem(hTab, idx, &item);

			ShowWindow(tab[display].Handle, SW_HIDE);	// ukrycie poprzedniego okna/ musi byc bo przy wielu liniach widac czesc okna na zakaldce /
			TabCtrl_SetCurSel(hTab, idx);				// aktywacja nowej zakldki
			display = idx;

			// tworzenie timera
			// ktory po x czasie zmieni pozycje okna czata
			// hack na centrowanie okna czata, ktorego nie mozna obejsc przez winapi
			TimerDef tdef;
			InitializeStruct(tdef);
				tdef.Interval = 1;	// 1ms
				tdef.FireCount = 1;
				tdef.CallBackFunc = TimerCallback;
				tdef.TimerID = "tab";
				tdef.Flags = TLEN_TIMER_FLAG_STARTAFTERCREATION | TLEN_TIMER_FLAG_AUTODESTROY;
			tlen_functions->CallTlenFunction(hInst, TLEN_TIMER_CALLFUNCTION, (WPARAM) TLEN_TIMER_CREATE, (LPARAM) &tdef);

			break;
		}

		case TLEN_CHATWINDOW_EVENT_AFTERCLOSED: {
			// jesli to okno nie bedace zakladka to olej
			bool ne = false;
			int i, j;
			j = tab.size();
			for (i=0; i<j; i++) {
				if (tab[i].Handle == ev->WindowInfo->Handle) {
					ne = true;
					break;
				}
			}
			if (!ne) return 0;

			// zabij wyswietlana zakladke
			TabCtrl_DeleteItem(hTab, display);
			tab.erase(&tab[display]);

			// przelacz na zakladke -1 (lewa)
			// jesli zaknieta o id=0 to a ilosc zakladek = 0 to zamknieto ostatnia zakladke
			// w przeciwnym razie pokaz najblizsza (prawa)
			if (display != 0) {
				display--;
				TabCtrl_SetCurSel(hTab, display);
			} else if (display == 0 && TabCtrl_GetItemCount(hTab) == 0) {
				// zabito ostatnia
				DestroyWindow(hOkno);
			} else {
				TabCtrl_SetCurSel(hTab, display);
			}
			SetTabPosition(display);
			LightItem(display, 0);	// wywal podswietlanie dla aktualnej zakladki
									// inaczej przy wyjsciu z pokoju, na nowej aktywnej zakadce bedzie podswietlanie, jesli predzej zostalo wlaczone
			break;
		}

		case TLEN_CHATWINDOW_EVENT_BEFOREFLASHBEGIN: {
			int i, j;
			j = tab.size();
			for (i=0; i<j; i++) {
				if (tab[i].Handle == ev->WindowInfo->Handle) {
					LightItem(i, 1);	// podswietlenie zakladki
					break;
				}
			}
			break;
		}

	}

	return 0;
}
